apiVersion: v1
kind: Secret
metadata:
  name: {{ gerrit_name }}-master
  namespace: {{ namespace }}
stringData:
  gerrit.config: |
    [gerrit]
            basePath = git
            serverId = {{ gerrit_server_id | default('cef467b6-2cbc-42d4-b21e-e4c29d1df424') }}
            canonicalWebUrl = https://{{ gerrit_fqdn }}/
    [core]
            packedGitLimit = {{ gerrit_packed_size_limit }}
    [index]
            type = LUCENE
    [sendemail]
{% if smtp_relay | default(False) %}
            enable = true
            smtpServer = {{ smtp_relay }}
            smtpServerPort = {{ smtp_port | default(25) }}
{% if smtp_port | default(25) | int == 25 %}
            smtpEncryption = none
{% else %}
            smtpEncryption = tls
{% endif %}
{% elif smtps_address | default(False) %}
            enable = true
            smtpServer = {{ smtps_address | urlsplit('hostname') }}
            smtpServerPort = {{ smtps_address | urlsplit('port') }}
            smtpEncryption = tls
{% elif smtp_address | default(False) %}
            enable = true
            smtpServer = {{ smtp_address | urlsplit('hostname') }}
            smtpServerPort = {{ smtp_address | urlsplit('port') }}
            smtpEncryption = none
{% else %}
            enable = false
{% endif %}
{% if skip_smtp_verify | default(False) %}
            sslVerify = false
{% else %}
            sslVerify = true
{% endif %}
    [sshd]
            advertiseAddress = {{ gerrit_name }}.{{ namespace }}.svc.{{ cluster_domain }}:29418
            listenAddress = *:29418
            threads = 8
            idleTimeout = 240m
            maxConnectionsPerUser = 0
    [httpd]
            listenUrl = proxy-https://*:8080
    [cache]
            directory = /var/gerrit/cache
    [cache "web_sessions"]
            maxAge = 5d
    [cache "ldap_groups"]
            maxAge = 60
    [cache "accounts"]
            maxAge = 60
    [cache "groups"]
            maxAge = 60
    [cache "groups_byinclude"]
            maxAge = 60
    [cache "groups_members"]
            maxAge = 60
    [download]
{% for scheme in gerrit_allowed_schemes %}
            scheme = {{ scheme }}
{% endfor %}
    [plugins]
            allowRemoteAdmin = true
    [container]
{% if gerrit_tag in [ '3.4.0-1', '3.4.1-1', '3.4.1-2' ] %}
            javaHome = /usr/lib/jvm/java-11-openjdk-amd64
{% else %}
            javaHome = /opt/jdk
{% endif %}
            javaOptions = "-Dflogger.backend_factory=com.google.common.flogger.backend.log4j.Log4jBackendFactory#getInstance"
            javaOptions = "-Dflogger.logging_context=com.google.gerrit.server.logging.LoggingContext#getInstance"
            javaOptions = -Djava.security.egd=file:/dev/urandom
            heapLimit = {{ gerrit_heap_limit | default('1200m') }}
            startupTimeout = 180
            user = gerrit
    [receive]
            enableSignedPush = false
    [auth]
{% if do_ldap %}
            type = LDAP
    [ldap]
            accountBase = ou=users,{{ ldap_secret.resources[0].data['directory-root'] | b64decode }}
            accountEmailAddress = mail
            accountFullName = sn
{% if do_fusion %}
            accountPattern = (&(objectClass=gosaAccount)(uid=${username})(!(pwdAccountLockedTime=*)))
{% else %}
            accountPattern = (&(objectClass={{ gerrit_ldap_user_objectclass }})(uid=${username})(!(pwdAccountLockedTime=*)))
{% endif %}
            accountScope = sub
            groupBase = ou=groups,{{ ldap_secret.resources[0].data['directory-root'] | b64decode }}
            groupMemberPattern = (&(objectClass=groupOfNames)(member=${dn}))
            groupName = cn
{% if do_fusion %}
            groupPattern = (&(objectClass=gosaGroupOfNames)(cn=${groupname}))
{% else %}
            groupPattern = (&(objectClass={{ gerrit_ldap_group_objectclass }})(cn=${groupname}))
{% endif %}
            groupScope = sub
            password = {{ ldap_secret.resources[0].data['gerrit-password'] | b64decode }}
{% if ldaps_address | default(False) %}
            server = {{ ldaps_address }}
{% if skip_ldap_verify | default(False) %}
            sslVerify = false
{% else %}
            sslVerify = true
{% endif %}
{% else %}
            server = {{ ldap_address }}
{% endif %}
            username = cn=gerrit,ou=services,{{ ldap_secret.resources[0].data['directory-root'] | b64decode }}
{% else %}
            type = DEVELOPMENT_BECOME_ANY_ACCOUNT
{% endif %}
{% if gerrit_db_type in [ 'mariadb', 'mysql' ] %}
    [accountPatchReviewDb]
            url = jdbc:mysql://{{ gerrit_ms_name }}:3306/{{ gerrit_database_name }}?user={{ gerrit_database_user }}&password={{ gerrit_database_pass }}
{% elif gerrit_db_type == 'postgres' %}
    [accountPatchReviewDb]
            url = jdbc:postgresql://{{ gerrit_pg_name }}:5432/{{ gerrit_database_name }}?user={{ gerrit_database_user }}&password={{ gerrit_database_pass }}
{% endif %}
  replication.config: |
{% if ((gerrit_replicas | int) - 1) > 0 %}
{% for n in range((gerrit_replicas | int) - 1) %}
    [remote "{{ gerrit_name }}-slave-{{ n }}"]
            url = admin@{{ gerrit_name }}-slave-{{ n }}.{{ gerrit_name }}-slave:/var/gerrit/git/${name}.git
            push = +refs/*:refs/*
            timeout = 30
            replicationDelay = 1
            threads = 4
            replicateHiddenProjects = true
            replicateProjectDeletions = true
            mirror = true
{% endfor %}
{% else %}
     #set gerrit_replicas >= 1 in your Gerrit definition to enable replication
{% endif %}
